﻿Module FGV_dx_circular_RK
    Public Function FGV_dx_Circular(Q As Double, S As Double, n As Double, D As Double, y1 As Double, Lf As Double, Li As Double, h As Double, hx As Double, yf As Double, theta As Double, alpha As Double, perf As String, dibujo As Graphics, xce As Integer, yce As Integer) As Double()
        Dim A, P, T, R, U, Fr, Sf, dydx, K1, k2, k3, k4, y2, y3, y4 As Double
        Dim g As Double = 9.81
        Dim i As Integer = 0
        Dim ii As Integer = 0
        Dim fallo As Integer = 0
        Dim xx As Double = 0
        Dim Y() As Double
        Dim X() As Double
        Dim Ys() As Double
        Dim Xs() As Double
        Dim Ye() As Double
        Dim Xe() As Double
        Dim Yse() As Double
        Dim Xse() As Double
        FGV.DataGridView1.Rows.Add(Li, Math.Round(y1, 4))
        Lf = Lf * hx '%distancia de recorrido
        '% ***********flujo gradualmente varido por Runge-Kutta dx***********
        While fallo = 0
            ' %*********Cálculo de k1
            A = A_Dy_circulo(D, y1)
            P = P_Dy_Circulo(D, y1)
            T = T_Dy_Circulo(D, y1)
            R = A / P
            U = Q / A
            Fr = Froude(A, g, U, alpha, theta, T)
            Sf = (n * U / R ^ (2 / 3)) ^ 2
            dydx = (S - Sf) / (1 - Fr ^ 2)
            K1 = h * dydx
            '  %**********Cálculo de k2 
            y2 = y1 + 0.5 * K1
            A = A_Dy_circulo(D, y2)
            P = P_Dy_Circulo(D, y2)
            T = T_Dy_Circulo(D, y2)
            R = A / P
            U = Q / A
            Fr = Froude(A, g, U, alpha, theta, T)
            Sf = (n * U / R ^ (2 / 3)) ^ 2
            dydx = (S - Sf) / (1 - Fr ^ 2)
            k2 = h * dydx
            ' %**********Cálculo de k3 
            y3 = y1 + 0.5 * k2
            A = A_Dy_circulo(D, y3)
            P = P_Dy_Circulo(D, y3)
            T = T_Dy_Circulo(D, y3)
            R = A / P
            U = Q / A
            Fr = Froude(A, g, U, alpha, theta, T)
            Sf = (n * U / R ^ (2 / 3)) ^ 2
            dydx = (S - Sf) / (1 - Fr ^ 2)
            k3 = h * dydx
            ' %**********Cálculo de k4 
            y4 = y1 + k3
            A = A_Dy_circulo(D, y4)
            P = P_Dy_Circulo(D, y4)
            T = T_Dy_Circulo(D, y4)
            R = A / P
            U = Q / A
            Fr = Froude(A, g, U, alpha, theta, T)
            Sf = (n * U / R ^ (2 / 3)) ^ 2
            dydx = (S - Sf) / (1 - Fr ^ 2)
            k4 = h * dydx
            If perf = "M2" And K1 < 0 Then
                K1 = K1 * -1
            End If
            If perf = "M2" And k2 < 0 Then
                k2 = k2 * -1
            End If
            If perf = "M2" And k3 < 0 Then
                k3 = k3 * -1
            End If
            If perf = "M2" And k4 < 0 Then
                k4 = k4 * -1
            End If
            If perf = "M1" And K1 > 0 Then
                K1 = K1 * -1
            End If
            If perf = "M1" And k2 > 0 Then
                k2 = k2 * -1
            End If
            If perf = "M1" And k3 > 0 Then
                k3 = k3 * -1
            End If
            If perf = "M1" And k4 > 0 Then
                k4 = k4 * -1
            End If
            '  %almacenamiento del tirante y distancia en vectores
            ReDim Preserve X(i) 'borra el vector --> equivalente a zeros() en matlab
            ReDim Preserve Y(i)
            ReDim Preserve Xs(i)
            ReDim Preserve Ys(i)
            Y(i) = y1
            X(i) = Li
            Xs(i) = xx
            Ys(i) = Y(i) - xx * (S)
            xx = xx + (h)
            ' %calculo de nuevo tirante con Runge-Kutta
            If i = Math.Abs((Lf / h) \ 1) Or Math.Abs(y1 - yf) < Math.Abs(0.0001) Or y1 > D Then
                fallo = 1  '          \ división entera
            End If
            y1 = y1 + 1 / 6 * (K1 + 2 * k2 + 2 * k3 + k4)
            Li = Li + h
            i = i + 1
        End While
        '%Revision de datos para imprimir solo 100 resultados
        ReDim Preserve X(i)
        ReDim Preserve Y(i)
        ReDim Preserve Xs(i)
        ReDim Preserve Ys(i)
        For iii = 1 To i - 1
            If iii Mod (i \ 100) = 0 Then '\ división entera
                ReDim Preserve Xe(ii)
                ReDim Preserve Ye(ii)
                ReDim Preserve Xse(ii)
                ReDim Preserve Yse(ii)
                Ye(ii) = Y(iii)
                Xe(ii) = X(iii)
                Xse(ii) = Xs(iii)
                Yse(ii) = Ys(iii)
                FGV.DataGridView2.Rows.Add(Math.Round(Xe(ii), 4), Math.Round(Ye(ii), 4))
                ii = ii + 1
            End If
        Next
        ReDim Preserve Xe(ii)
        ReDim Preserve Ye(ii)
        FGV_dx_Circular = Ye
        'Llamar a la gráfica
        ReDim Preserve Xse(ii - 1)
        ReDim Preserve Yse(ii - 1)
        Graf_perfil(Xse, Yse, S, dibujo, xce, yce)
    End Function
End Module
